
using System;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;

/// <summary>
/// Body Shader 1.0.0, by Acid Bubbles
/// Concept developed by Skeet
/// Allows applying custom shaders to persons
/// </summary>
public class XRayWomb : MVRScript
{
    private const string DefaultShaderKey = "Keep default";

    public static readonly Dictionary<string, string[]> GroupedMaterials = new Dictionary<string, string[]>
    {
		
		{
            "Glass",
             new[]
            {
                "defaultMat",
                "Anus",
                "Genitalia",
                "Hips",

            }
		},


        };
	private DAZMorph GlassHelper;
    private Atom _person;
    private DAZCharacterSelector _selector;
    private bool _dirty;
    private DAZCharacter _character;
    private Dictionary<Material, Shader> _original;
    private List<MapSettings> _map = new List<MapSettings>();
    private DAZHairGroup _hair;
    private JSONStorableStringChooser _applyToJSON;
    private JSONStorableStringChooser _shaderJSON;
    private JSONStorableFloat _alphaJSON;
    private JSONStorableFloat _renderQueue;
	DAZClothingItem item1;
	DAZClothingItem item1a;

    private class MapSettings
    {
        public string ShaderName { get; set; }
        public string MaterialName { get; set; }
        public float Alpha { get; set; }
        public int RenderQueue { get; set; }
    }

    public override void Init()
    {
        try
        {
            if (containingAtom?.type != "Person")
            {
                SuperController.LogError($"This plugin only works on Person atoms");
                DestroyImmediate(this);
                return;
            }

            _person = containingAtom;
            _selector = _person.GetComponentInChildren<DAZCharacterSelector>();
			item1 = _selector
					.clothingItems
					.First(h => h.displayName == "Xray Womb");
			item1a = _selector
					.clothingItems
					.First(h => h.displayName == "Xray Womb 2");
			/////////////////////////////////////////////////////////////////////

			        foreach (var mat in GroupedMaterials.Values.SelectMany(v => v).Distinct())
        {
            var settings = new MapSettings { MaterialName = mat };
            _map.Add(settings);
        }

            _dirty = true;
        }
        catch (Exception e)
        {
            SuperController.LogError("Failed to init: " + e);
            DestroyImmediate(this);
        }
    }

    public void Update()
    {
        try
        {
			_selector.SetActiveClothingItem(item1, true);
			_selector.SetActiveClothingItem(item1a, true);
            if (!_dirty)
            {
                if (_selector.selectedCharacter != _character)
                    _dirty = true;
                return;
            }

            _character = _selector.selectedCharacter;
            if (_character == null) return;
            var skin = _character.skin;
            if (skin == null) return;

            if (_original == null)
            {
                _original = new Dictionary<Material, Shader>();
                foreach (var mat in skin.GPUmaterials)
                {
                    _original.Add(mat, mat.shader);
                }
            }

            foreach (var setting in _map)
            {
                if (setting.ShaderName == DefaultShaderKey || setting.ShaderName == null) ;
			var shader = Shader.Find("Custom/Subsurface/TransparentGlossNoCullSeparateAlphaComputeBuff");

                if (shader == null) return;
                var mat = skin.GPUmaterials.FirstOrDefault(x => x.name == setting.MaterialName);
                if (mat == null) continue;
                mat.shader = shader;
                mat.SetFloat("_AlphaAdjust", -0.99f);
                mat.renderQueue = 5000;
            }

            skin.BroadcastMessage("OnApplicationFocus", true);
            _dirty = false;
        }
        catch (Exception e)
        {
            SuperController.LogError("something failed: " + e);
        }
    }

    public void OnDisable()
    {
        try
        {
			_selector.SetActiveClothingItem(item1, false);
			_selector.SetActiveClothingItem(item1a, false);
            _dirty = true;
            if (_original != null)
            {
                foreach (var x in _original)
                    x.Key.shader = x.Value;
            }
            _character?.skin?.BroadcastMessage("OnApplicationFocus", true);
			
	
        }
        catch (Exception e)
        {
            SuperController.LogError("something failed: " + e);
        }
    }

    public void OnDestroy()
    {
        OnDisable();
    }
}

